// file      : examples/cxx/tree/hello/driver.cxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : not copyrighted - public domain

#include <memory>   // std::auto_ptr
#include <iostream>
#include <fstream>

#include "hello9.hxx"

using namespace std;

int
main (int argc, char* argv[])
{
  if (argc != 2)
  {
    cerr << "usage: " << argv[0] << " hello.xml" << endl;
    return 1;
  }

  try
  {
    auto_ptr<xplangml::XPlanAuszugType> Auszug (xplangml::XPlanAuszug (argv[1]));

    xplangml::XPlanAuszugType copy (*Auszug); // Dynamic types are preserved in copies.

    // Print what we've got.
    //
    for (gml::AbstractFeatureCollectionType::featureMember_const_iterator i (copy.featureMember().begin());
         i != copy.featureMember ().end ();
         ++i)
    {
      if (const xplangml::BP_PlanType* s = dynamic_cast<const xplangml::BP_PlanType*> (&*i))
      {
        cout << "BP_Plan" << endl;
      }
      else
      {
        cout << "no BP_Plan" << endl;
      }
    }
  }
  catch (const xml_schema::exception& e)
  {
    cerr << e << endl;
    return 1;
  }
}
